
	struct RECT
	{
		unsigned char X,Y,Width,Height;	
	};

	struct VPORT
	{
		unsigned char Left,Top,Right,Bottom;	
	};

	struct GOBJ
	{
		int X,Y;			// (*) A sprite 16 bites előjeles koordinátája.
		unsigned char SprInd;		// (*) A sprite indexe az exportált munkamenetben
		unsigned char Flag;		// (*) 0. bit: jelzi, hogy a sprite be van-e kapcsolva, a 7. pedig, ha tükrözni kell.
		char *SprBackAddr;		// (*) A sprite háttér mentése számára lefoglalt mem. blokk kezdőcíme. Ha nem kell menteni a hátteret akkor az értéke 0!
		char *SprPalAddr;		// (*) A sprite palettájának címe. Ha nincs paletta, akkor értéke 0!
		int (*spritefunc)();		// (*) A sprite kirajzoló rutin kezdőcíme
		unsigned char SprWidth;		// A sprite szélessége
		unsigned char SprHeight;	// A sprite magassága
		unsigned char SprIndRef;	// Sprite index referencia. Azért kell, hogy el tudjuk dönteni kell-e újra inicializálni a sprite alap adatait (pl. RawAddr)
		char *SprRawAddr;		// Az adott sprite forrás adatai
		char *SprScrAddr;		// A sprite vágás utáni kezdőcíme a képernyőn v. háttér bufferben
		unsigned char SprClipSkipRow;	// A sprite felső vágásánál ezen a változón tárolódik, hogy hány sort kell felül kihagynia a sprite kirajzolónak
		struct RECT SprClip;		// A sprite vágás utáni dimenziói
		struct RECT SprPrevClip;	// A sprite előző fázisban értelmezett vágás utáni dimenziói
		unsigned char SprClipFlag;	// A sprite vágási állapotát tárolja le a sprite kirakónak
	};

	struct SCNSPRITE
	{
	        unsigned char SprInd;		// A sprite indexe (*)
	        int X,Y;			// A sprite 16 bites előjeles koordinátája. (*)
	        unsigned char SprWidth;		// A sprite szélessége. (*)
	        unsigned char SprHeight;	// A sprite magassága. (*)
	        unsigned char Tag;		// A scene editorban a sprite-hoz rendelt Tag (*)
	        unsigned char *SprPalette;	// A sprite palettájának címe. Alapból 0, de a működés során tetszőlegesen megváltoztatható. Feltéve, ha a kirajzoló használja a sprite palettát.
	        char Visible;			// Ezzel a tulajdonsággal kikapcsolhatjuk a sprite kirajzolását. Ha ezt a változót 0-ra állítjuk (false) akkor az adott sprite nem fog kirajzolódni
	};

char palWall[] = {0,PAL_RED*3,PAL_DARKRED*3,PAL_WHITE*3};
char palLift[] = {0,PAL_YELLOW*3,PAL_DARKRED*3};

unsigned char tileMap[32*26];

main()
{
	memset(tileMap,0,32*26);

	DbInitGameLib(GRAPH_MODE16, 0, 0);

	DbPageFullRamVid();
	DbAssignRenderToVideo();

	DbDrawScene(0, DbSprite16c8Cut, true);


	WaitForKeyPress(KEY_4);
	DbCloseGameLib();

	PrnConsole(utos(GetTileMap(7,161)));
	PrnConsole("\r\n\r\b");
}

DbSceneCallBack()
{
	int tileMapX,tileMapY, tileW;
	unsigned char *tileAddr;

	struct SCNSPRITE *scnSpriteParam;
	scnSpriteParam = SceneDrawSprParam;

	// Innen lehet írni a saját kódunkat..

	if(scnSpriteParam->SprInd <= 3)
		scnSpriteParam->SprPalette = palWall;
	else if(scnSpriteParam->SprInd == 4)
		scnSpriteParam->SprPalette = palLift;

	if(scnSpriteParam->Tag == 3 || scnSpriteParam->Tag == 12 || scnSpriteParam->SprInd == 4)
	{
		tileMapX = scnSpriteParam->X >> 1;
		tileMapY = (scnSpriteParam->Y - 10) >> 3;

		tileW = scnSpriteParam->SprWidth >> 1;

		tileAddr = tileMap + tileMapX + (tileMapY << 5);	// tileMap * 32

		while(tileW)
		{
			*tileAddr++ = scnSpriteParam->Tag;
			--tileW;
		}
	}
}

GetTileMap(int X, int Y)
{
	int tileMapX,tileMapY;
	unsigned char *tileAddr;

	tileMapX = X >> 1;
	tileMapY = (Y - 10) >> 3;

	tileAddr = tileMap + tileMapX + (tileMapY << 5);

	return *tileAddr;
}

#asm   /* A grafikus munkaasztalból importált adatok. NE VÁLTOZTASD MEG! */
		;{	Enumerált sprite indexek. Célszerű a főprogram elejére másolni!
				enum	SPR_IND_FENYCSOVEK,
					SPR_IND_FAL,
					SPR_IND_PADLO_VEG,
					SPR_IND_PADLO,
					SPR_IND_LIFT,
					SPR_IND_TERMINAL,
					SPR_IND_ITEM_HIFI,
					SPR_IND_ITEM_SPEAKER_2,
					SPR_IND_ITEM_CANDY,
					SPR_IND_ITEM_MAINFRAME,
					SPR_IND_ITEM_SZALAGOS,
					SPR_IND_ITEM_COMPUTER,
					SPR_IND_ITEM_FRIDGE,
					SPR_IND_ITEM_BOOKS,
					SPR_IND_ITEM_DISHWASHER,
					SPR_IND_ITEM_HDD,
					SPR_IND_ITEM_ASZTAL,
					SPR_IND_ROBOT_01,
					SPR_IND_PLAYER

		;}

	GfxBaseAddr		dw	SpriteCount-GfxBaseAddr,SceneCount-GfxBaseAddr,0

	;{   Sprite-ok adatai (Automatikusan beemelve!)
	SpriteCount		db 19
	SpriteIndexArray
				dw	0,20,36,49,65,100,162,226,292,460,533,665,733,797,973,1133,1194,1363,1446

	SpriteDataBuffer	ds	0,0
	DecompressBuffer	ds	0,0

	SpriteBaseAddr
	fenycsovek
				db	12			; A sprite szélessége byte-okban
				db	8			; A sprite magassága
				db	226,226,161,18,33,18,33,18,33,18,33,225,225,161,194,226,162,195
	fal
				db	2			; A sprite szélessége byte-okban
				db	8			; A sprite magassága
				db	17,18,17,18,17,18,17,18,17,18,17,18,146,146
	padlo_veg
				db	2			; A sprite szélessége byte-okban
				db	8			; A sprite magassága
				db	147,147,147,146,33,17,33,17,33,17,146
	padlo
				db	4			; A sprite szélessége byte-okban
				db	8			; A sprite magassága
				db	163,163,163,162,33,145,18,33,145,18,33,145,18,162
	lift
				db	6			; A sprite szélessége byte-okban
				db	8			; A sprite magassága
				db	177,177,177,34,33,17,34,33,17,18,34,17,18,34,17,17,34,33,17,34,33,17,18,34,17,18,34,33,17,34,33,17
				db	34
	terminal
				db	3+128			; A sprite szélessége byte-okban
				db	22			; A sprite magassága
				db	0,3,192,195,207,51,255,63			; A sprite szín adatai
				db	158,97,17,38,65,83,36,97,51,38,66,33,20,98,33,22,158,153,158,98,114,118,103,39,38,158,159,155,0,119,0,0
				db	103,0,0,103,0,0,103,0,0,103,0,0,103,0,0,103,0,2,115,16
	item_hifi
				db	4+128			; A sprite szélessége byte-okban
				db	18			; A sprite magassága
				db	0,3,12,192,48,252,255,63			; A sprite szín adatai
				db	6,151,112,1,147,16,103,151,118,115,147,55,115,37,117,55,113,145,23,167,115,147,55,115,71,71,55,113,145,23,167,115
				db	147,55,115,119,53,55,115,85,51,55,113,145,23,112,144,7,112,144,7,48,144,3
	item_speaker_2
				db	4+128			; A sprite szélessége byte-okban
				db	16			; A sprite magassága
				db	0,3,192,195,255,0,0,63			; A sprite szín adatai
				db	71,151,64,154,32,50,146,48,34,18,18,32,33,33,33,32,33,19,17,32,33,49,49,32,35,19,19,32,33,49,49,32
				db	33,19,17,32,33,33,33,32,34,18,18,32,50,146,48,154,32,71,151,64,2,19,18,0
	item_candy
				db	8+128			; A sprite szélessége byte-okban
				db	29			; A sprite magassága
				db	0,3,12,15,48,51,60,255			; A sprite szín adatai
				db	7,191,5,85,34,38,102,68,113,113,5,119,39,38,118,71,65,17,5,119,34,38,118,71,71,23,5,85,39,38,118,68
				db	71,23,7,191,1,185,7,191,7,191,7,55,39,103,103,87,71,119,7,183,23,7,55,39,103,103,87,71,23,7,55,39
				db	103,103,87,71,23,7,55,39,103,103,87,71,87,7,55,39,103,103,87,71,119,7,55,39,103,103,87,71,119,7,55,39
				db	103,103,87,71,119,7,55,39,103,103,87,71,119,7,55,39,103,103,87,71,119,7,191,7,55,39,103,103,87,71,119,7
				db	55,39,103,103,87,71,119,7,183,23,7,169,23,23,7,169,23,23,7,173,87,87,7,191,2,177,18,0,178,32
	item_mainframe
				db	10+128			; A sprite szélessége byte-okban
				db	28			; A sprite magassága
				db	0,3,12,195,204,255,0,63			; A sprite szín adatai
				db	213,209,211,211,53,53,53,187,51,115,115,187,211,211,211,213,215,211,20,17,20,20,17,20,17,20,18,17,209,211,18,20
				db	17,20,17,18,20,17,20,20,209,211,17,18,20,17,20,20,17,20,18,17,209,211,213,215,211,211,211,209,16,192,1
	item_szalagos
				db	6+128			; A sprite szélessége byte-okban
				db	27			; A sprite magassága
				db	0,192,12,204,255,0,60,63			; A sprite szín adatai
				db	116,164,112,172,64,66,154,67,64,66,102,98,34,66,64,70,150,34,68,64,70,150,18,68,64,70,98,102,33,67,64,70
				db	98,102,39,68,64,70,150,39,68,64,70,150,36,67,64,66,102,98,39,68,64,66,146,36,68,64,66,102,98,39,66,64
				db	70,150,36,68,64,70,150,39,68,64,70,98,102,39,66,64,70,98,102,33,68,64,70,150,18,68,64,70,150,34,67,64
				db	66,102,98,34,66,64,66,154,68,64,71,159,68,64,172,64,172,64,172,64,116,164,112,16,160,16
	item_computer
				db	4+128			; A sprite szélessége byte-okban
				db	22			; A sprite magassága
				db	0,3,12,192,195,204,255,63			; A sprite szín adatai
				db	0,6,86,0,0,6,102,96,0,6,38,102,0,6,38,102,0,6,150,0,6,38,103,0,7,39,112,144,68,0,0,150
				db	112,6,150,96,158,103,167,164,1,153,0,155,152,51,152,3,152,3,152,3,152,3,0,155,3,155
	item_fridge
				db	5+128			; A sprite szélessége byte-okban
				db	31			; A sprite magassága
				db	0,3,192,252,255,0,60,63			; A sprite szín adatai
				db	100,156,70,171,171,163,50,163,55,163,55,163,55,163,55,163,50,171,99,155,54,169,100,156,70,171,163,50,163,55,163,55
				db	163,55,163,55,163,55,163,50,171,171,171,171,171,171,171,171,99,155,54,2,154,32
	item_books
				db	6+128			; A sprite szélessége byte-okban
				db	36			; A sprite magassága
				db	0,192,12,195,48,243,60,252			; A sprite szín adatai
				db	182,182,103,160,118,98,83,39,82,2,86,103,83,39,66,2,118,98,83,39,82,2,86,103,83,39,66,2,118,182,96,0
				db	82,0,64,6,99,66,82,82,71,6,99,82,82,66,71,6,99,66,82,82,71,6,99,82,82,66,71,6,182,103,160,38
				db	101,69,36,53,117,38,103,69,37,53,116,38,101,69,36,53,117,38,103,69,37,53,116,38,182,96,160,86,96,117,50,66
				db	82,70,96,53,55,66,82,86,96,117,50,66,82,70,96,53,55,66,82,86,96,117,50,66,82,70,182,96,160,6,98,0
				db	82,4,32,86,98,115,66,117,36,38,98,3,82,116,36,86,98,115,66,117,36,38,98,3,82,116,36,86,98,115,66,117
				db	36,38,182,16,160,1
	item_dishwasher
				db	12+128			; A sprite szélessége byte-okban
				db	23			; A sprite magassága
				db	0,3,12,243,252,51,255,63			; A sprite szín adatai
				db	192,166,192,164,192,69,53,53,66,192,67,115,115,68,192,71,55,55,66,160,96,152,67,115,115,68,160,48,152,70,150,68
				db	152,32,112,16,144,164,144,7,103,119,103,144,167,4,220,7,223,0,21,149,21,149,21,157,16,0,83,147,83,147,83,155
				db	80,0,83,147,83,147,83,51,99,51,80,0,83,147,83,147,83,51,115,51,80,0,83,51,54,86,147,83,155,80,0,83
				db	51,55,87,147,165,80,0,83,147,83,147,83,155,80,0,83,147,83,147,83,51,99,51,80,0,83,147,83,147,83,51,115
				db	51,80,0,83,147,83,147,83,155,80,0,83,147,83,147,83,155,80,0,1,201,0
	item_hdd
				db	4+128			; A sprite szélessége byte-okban
				db	21			; A sprite magassága
				db	0,192,12,195,204,252,60,255			; A sprite szín adatai
				db	7,149,80,87,81,21,85,82,148,37,87,81,21,85,82,148,37,87,81,21,85,82,148,37,87,81,21,85,82,148,37,163
				db	34,82,66,66,34,82,66,66,163,166,166,166,166,166,165,162,16,144,1
	item_asztal
				db	13+128			; A sprite szélessége byte-okban
				db	24			; A sprite magassága
				db	0,192,12,204,252,255,60,63			; A sprite szín adatai
				db	144,85,208,144,174,176,144,87,144,153,168,144,96,144,100,85,70,168,144,96,208,144,96,208,144,96,208,144,96,208,144,96
				db	208,144,103,144,69,85,84,168,144,102,97,0,155,168,117,165,154,165,87,86,150,101,102,154,102,86,150,101,86,101,86,103
				db	87,154,117,118,101,86,101,86,150,96,0,154,0,6,150,101,81,145,16,1,154,16,1,145,21,86,150,96,7,154,112,6
				db	150,101,86,150,96,5,152,80,6,150,101,86,101,86,96,5,155,80,6,101,86,101,86,150,96,7,154,112,6,150,101,86
				db	150,96,144,17,144,6,150,101,86,150,96,144,119,144,6,150,101,80,160,112,85,7,160,5,80,160,23,119,113,160,5
	robot_01
				db	4+128			; A sprite szélessége byte-okban
				db	21			; A sprite magassága
				db	0,195,204,255,0,0,0,0			; A sprite szín adatai
				db	0,32,144,0,32,144,3,51,0,16,17,51,3,16,153,16,3,51,3,16,0,3,0,16,0,51,48,0,1,49,49,0
				db	155,48,19,35,35,16,19,50,51,48,155,16,51,17,19,48,19,17,19,16,19,17,19,48,155,48,3,19,19,0,0,17
				db	16,0,0,17,16,0,0,2,144
	player
				db	3+128			; A sprite szélessége byte-okban
				db	31			; A sprite magassága
				db	0,192,255,0,0,0,0,0			; A sprite szín adatai
				db	152,152,152,0,1,16,0,1,32,0,2,32,0,2,32,0,2,0,0,18,0,0,34,0,0,34,0,0,33,0,0,33
				db	0,0,34,0,1,34,0,1,18,32,1,16,34,1,17,2,1,17,0,1,17,16,1,17,16,0,17,16,0,16,17,1
				db	16,17,1,17,16,1,1,16,17,1,16,16,1,0,16,17,0,16,17,0,17,1,16

	;}
	;{   A Scene-ek adatai (Automatikusan beemelve!)
	SceneCount		db 3
	SceneIndexArray
				dw	0,120,287
	SceneBaseAddr
				db	20		;  scene sorok száma
				db	17	; A paletta / háttér szín
 				db	136,2,12,0,210,88,3,12,8,66,12,4,4,48,152,1,3,62,18,25,8,24,1,3,0,18,19,8,24,4,128,2
				db	162,2,48,24,4,129,56,114,3,48,8,5,48,11,189,8,5,48,24,93,8,8,32,43,181,8,10,33,22,135,8,10
				db	34,28,135,8,9,35,10,86,8,15,36,44,93,8,16,37,26,42,8,11,38,45,44,136,17,67,48,143,136,17,66,32
				db	95,8,17,67,16,47,64,0,0,0,0,10,0,6,12,0,18,0,254,255,181,0				
				db	25		;  scene sorok száma
				db	16	; A paletta / háttér szín
 				db	8,2,12,0,210,88,3,12,8,114,2,4,3,48,72,3,12,22,210,10,4,88,3,12,22,114,2,4,2,48,72,3
				db	12,2,66,7,4,88,3,12,36,66,2,4,3,48,80,3,12,50,0,66,0,4,4,3,48,24,1,3,0,18,19,8
				db	136,1,3,62,18,152,1,3,62,74,18,8,8,5,48,11,189,24,4,130,2,162,2,48,24,4,162,16,162,2,48,24
				db	4,129,30,114,2,48,24,4,161,44,114,2,48,8,16,32,44,186,8,13,33,37,126,8,13,34,53,78,8,6,35,12
				db	48,8,7,36,4,50,8,7,37,20,50,136,17,64,22,47,8,17,65,37,191,128,18,17,63,0,37,0,64,0,0,0
				db	0,10,0,6,12				
				db	18		;  scene sorok száma
				db	20	; A paletta / háttér szín
 				db	8,2,12,62,210,24,2,12,54,66,4,48,88,3,12,34,66,5,4,4,48,88,3,12,8,66,5,4,4,48,24,1
				db	3,0,18,25,8,152,1,3,62,18,19,8,8,5,48,49,189,24,4,129,2,114,3,48,24,4,161,28,114,3,48,24
				db	4,193,56,114,3,48,8,8,32,42,37,8,12,33,22,35,8,14,34,8,43,136,17,67,18,95,136,17,67,40,143,8
				db	17,66,37,47,128,18,17,63,0,181,0,64,0,0,0,0,10,0,6,12				

	;}


#endasm